【CodeForces】266E More Queries to Array... 线段树

2024-09-05 15:58

本文主要是介绍【CodeForces】266E More Queries to Array... 线段树,希望对大家解决编程问题提供一定的参考价值,需要的开发者们随着小编来一起学习吧!

E. More Queries to Array...
time limit per test
5 seconds
memory limit per test
256 megabytes
input
standard input
output
standard output

You've got an array, consisting of n integers: a1, a2, ..., an. Your task is to quickly run the queries of two types:

  1. Assign value x to all elements froml to r inclusive. After such query the values of the elements of arrayal, al + 1, ..., ar become equal tox.
  2. Calculate and print sum , wherek doesn't exceed 5. As the value of the sum can be rather large, you should print it modulo1000000007 (109 + 7).
Input

The first line contains two integers n and m (1 ≤ n, m ≤ 105), showing, how many numbers are in the array and the number of queries, correspondingly. The second line contains n integers: a1, a2, ..., an (0 ≤ ai ≤ 109) — the initial values of the array elements.

Then m queries follow, one per line:

  1. The assign query has the following format: "", (1 ≤ l ≤ r ≤ n; 0 ≤ x ≤ 109).
  2. The query to calculate the sum has the following format: "", (1 ≤ l ≤ r ≤ n; 0 ≤ k ≤ 5).

All numbers in the input are integers.

Output

For each query to calculate the sum print an integer — the required sum modulo1000000007 (109 + 7).

Sample test(s)
Input
4 5
5 10 2 1
? 1 2 1
= 2 2 0
? 2 4 3
= 1 4 1
? 1 4 5
Output
25
43
1300
Input
3 1
1000000000 1000000000 1000000000
? 1 3 0
Output
999999986

传送门:【CodeForces】266E More Queries to Array... 


题目大意:

给你一串数,编号从1~n,进行m次操作。(1 <= n , m <= 10 ^ 5 )

= L R X 区间【L,R】上的数设为X

?L R K 输出


题目分析:

本题主要还是数学拆项的思想。

一开始我们直接将每个数设成ai * (i ^ k)。这样条件k下整个序列的和就是sum (ai * ( i ^ k ) ) ,我们需要分别保存每个k对应的和。

接下来,如果我们要求区间【L,R】上条件k下的和。

那么答案ans = sum ( ai * ( ( i - l + 1 ) ^ k ) ) (l <= i <= r )。这样我们就需要将其转化。

对于sum中的一项 ai * ( ( i - L + 1 ) ^ k ),我们需要转化成ai * ( i ^ k )

我们可以进行二项式拆项:

ai * ( ( i - L + 1 ) ^ k ) =

ai * ( C( k , 0 ) * ( ( 1 - L ) ^ k ) ) * ( i ^ 0 ) +

C( k , 1 ) * ( ( 1 - L ) ^ ( k - 1 ) ) * ( i ^ 1 ) + ... + C( k , k ) * ( ( 1 - L ) ^ 0 ) * ( i ^ k ) 。

那么我们只要预处理出组合数C,以及1^k + 2^k + ... + n^k 的前缀和即可。

具体部分看代码就行了。


代码如下:


#include <cstdio>
#include <cstring>
#include <algorithm>
using namespace std ;typedef long long BigInt ;#define ls ( o << 1 )
#define rs ( o << 1 | 1 )
#define rt o , l , r
#define root 1 , 1 , n
#define lson ls , l , m
#define rson rs , m + 1 , r
#define mid ( ( l + r ) >> 1 )
#define clear( A , X ) memset ( A , X , sizeof A )const int maxK = 6 ;
const int maxN = 100005 ;
const int MOD = 1e9 + 7 ;BigInt sum[maxN << 2][maxK] , S[maxN][maxK] ;
int set[maxN << 2] , C[maxK][maxK] ;BigInt Pow ( int x , int n ) {BigInt a = 1 , b = x ;while ( n ) {if ( n & 1 ) a = a * b % MOD ;b = b * b % MOD ;n >>= 1 ;}return a ;
}void Ready () {for ( int i = 0 ; i < maxK ; ++ i ) {C[i][0] = 1 ;for ( int j = 1 ; j <= i ; ++ j ) {C[i][j] = C[i - 1][j - 1] + C[i - 1][j] ;}}for ( int i = 0 ; i < maxN ; ++ i ) {S[i][0] = 0 ;for ( int j = 0 ; j < maxK ; ++ j ) {S[i][j] = ( S[i - 1][j] + Pow ( i , j ) ) % MOD ;}}
}void Cal ( int v , int o , int l , int r ) {set[o] = v ;for ( int i = 0 ; i < maxK ; ++ i ) {sum[o][i] = ( S[r][i] - S[l - 1][i] + MOD ) % MOD * v % MOD ;}
}void PushUp ( int o ) {for ( int i = 0 ; i < maxK ; ++ i ) {sum[o][i] = ( sum[ls][i] + sum[rs][i] ) % MOD ;}
}void PushDown ( int o , int l , int r ) {if ( ~set[o] ) {int m = mid ;Cal ( set[o] , lson ) ;Cal ( set[o] , rson ) ;set[o] = -1 ;}
}void Update ( int L , int R , int v , int o , int l , int r ) {if ( L <= l && r <= R ) {Cal ( v , rt ) ;return ;}PushDown ( rt ) ;int m = mid ;if ( L <= m ) Update ( L , R , v , lson ) ;if ( m <  R ) Update ( L , R , v , rson ) ;PushUp ( o ) ;
}BigInt Query ( int L , int R , int k , int o , int l , int r ) {if ( L <= l && r <= R ) {BigInt res = 0 , tmp = 1 ;for ( int i = k ; i >= 0 ; -- i ) {res = ( res + sum[o][i] * C[k][i] % MOD * tmp % MOD + MOD ) % MOD ;tmp = tmp * ( 1 - L ) % MOD ;}return res ;}PushDown ( rt ) ;int m = mid ;BigInt ans = 0 ;if ( L <= m ) ans = ( ans + Query ( L , R , k , lson ) ) % MOD ;if ( m <  R ) ans = ( ans + Query ( L , R , k , rson ) ) % MOD ;return ans ;
}void Build ( int o , int l , int r ) {set[o] = -1 ;if ( l == r ) {int x ;scanf ( "%d",  &x ) ;for ( int i = 0 ; i < maxK ; ++ i ) sum[o][i] = Pow ( l , i ) * x % MOD ;return ;}int m = mid ;Build ( lson ) ;Build ( rson ) ;PushUp ( o ) ;
}void work () {int n , m , l , r , v ;char ch ;Ready () ;while ( ~scanf ( "%d%d" , &n , &m ) ) {Build ( root ) ;while ( m -- ) {getchar () ;scanf ( "%c%d%d%d" , &ch , &l , &r , &v ) ;if ( '=' == ch ) Update ( l , r , v , root ) ;if ( '?' == ch ) printf ( "%I64d\n" , Query ( l , r , v , root ) ) ;}}
}int main () {work () ;return 0 ;
}



这篇关于【CodeForces】266E More Queries to Array... 线段树的文章就介绍到这儿,希望我们推荐的文章对编程师们有所帮助!



http://www.chinasem.cn/article/1139413

相关文章

poj3468(线段树成段更新模板题)

题意:包括两个操作:1、将[a.b]上的数字加上v;2、查询区间[a,b]上的和 下面的介绍是下解题思路: 首先介绍  lazy-tag思想:用一个变量记录每一个线段树节点的变化值,当这部分线段的一致性被破坏我们就将这个变化值传递给子区间,大大增加了线段树的效率。 比如现在需要对[a,b]区间值进行加c操作,那么就从根节点[1,n]开始调用update函数进行操作,如果刚好执行到一个子节点,

hdu1394(线段树点更新的应用)

题意:求一个序列经过一定的操作得到的序列的最小逆序数 这题会用到逆序数的一个性质,在0到n-1这些数字组成的乱序排列,将第一个数字A移到最后一位,得到的逆序数为res-a+(n-a-1) 知道上面的知识点后,可以用暴力来解 代码如下: #include<iostream>#include<algorithm>#include<cstring>#include<stack>#in

hdu1689(线段树成段更新)

两种操作:1、set区间[a,b]上数字为v;2、查询[ 1 , n ]上的sum 代码如下: #include<iostream>#include<algorithm>#include<cstring>#include<stack>#include<queue>#include<set>#include<map>#include<stdio.h>#include<stdl

hdu 1754 I Hate It(线段树,单点更新,区间最值)

题意是求一个线段中的最大数。 线段树的模板题,试用了一下交大的模板。效率有点略低。 代码: #include <stdio.h>#include <string.h>#define TREE_SIZE (1 << (20))//const int TREE_SIZE = 200000 + 10;int max(int a, int b){return a > b ? a :

hdu 1166 敌兵布阵(树状数组 or 线段树)

题意是求一个线段的和,在线段上可以进行加减的修改。 树状数组的模板题。 代码: #include <stdio.h>#include <string.h>const int maxn = 50000 + 1;int c[maxn];int n;int lowbit(int x){return x & -x;}void add(int x, int num){while

poj 1127 线段相交的判定

题意: 有n根木棍,每根的端点坐标分别是 px, py, qx, qy。 判断每对木棍是否相连,当他们之间有公共点时,就认为他们相连。 并且通过相连的木棍相连的木棍也是相连的。 解析: 线段相交的判定。 首先,模板中的线段相交是不判端点的,所以要加一个端点在直线上的判定; 然后,端点在直线上的判定这个函数是不判定两个端点是同一个端点的情况的,所以要加是否端点相等的判断。 最后

HDU4737线段树

题目大意:给定一系列数,F(i,j)表示对从ai到aj连续求或运算,(i<=j)求F(i,j)<=m的总数。 const int Max_N = 100008 ;int sum[Max_N<<2] , x[Max_N] ;int n , m ;void push_up(int t){sum[t] = sum[t<<1] | sum[t<<1|1] ;}void upd

Codeforces Round #240 (Div. 2) E分治算法探究1

Codeforces Round #240 (Div. 2) E  http://codeforces.com/contest/415/problem/E 2^n个数,每次操作将其分成2^q份,对于每一份内部的数进行翻转(逆序),每次操作完后输出操作后新序列的逆序对数。 图一:  划分子问题。 图二: 分而治之,=>  合并 。 图三: 回溯:

zoj 1721 判断2条线段(完全)相交

给出起点,终点,与一些障碍线段。 求起点到终点的最短路。 枚举2点的距离,然后最短路。 2点可达条件:没有线段与这2点所构成的线段(完全)相交。 const double eps = 1e-8 ;double add(double x , double y){if(fabs(x+y) < eps*(fabs(x) + fabs(y))) return 0 ;return x + y ;

Codeforces Round #261 (Div. 2)小记

A  XX注意最后输出满足条件,我也不知道为什么写的这么长。 #define X first#define Y secondvector<pair<int , int> > a ;int can(pair<int , int> c){return -1000 <= c.X && c.X <= 1000&& -1000 <= c.Y && c.Y <= 1000 ;}int m